#!/bin/env python
# -*- coding:utf-8 -*-
# -------------------------------
# Filename:   
# Revision:    2.0
# Date:        2012-12-5
# Author:      simonzhang
# Email:       simon-zzm@163.com
# Web:         www.simonzhang.net
# 
# 1.0 create script
# 2.0 add check global ip  
# -------------------------------
import os
import re
import urllib2
import time
import socket
import fcntl
import struct
import smtplib
from email.mime.text import MIMEText


mail_host = 'smtp.exmail.qq.com'
mail_user = 'warning@qq.net'
mail_pwd = 'aaabbbb'

def get_ip_address(ifname):
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    try:
        return socket.inet_ntoa(fcntl.ioctl(
            s.fileno(),
            0x8915,  # SIOCGIFADDR
            struct.pack('256s', ifname[:15])
         )[20:24])
    except IOError, e:
        return e


def get_global_ip():
    get_html =  urllib2.urlopen('http://iframe.ip138.com/ic.asp').read()
    _re_ip = re.compile(r'\d{2,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}', re.DOTALL)
    _global_ip = _re_ip.findall(get_html)[0]
    return _global_ip
 
def mail_send(content, mailto, get_sub):
    msg = MIMEText(content.encode('utf8'), _subtype='html',  _charset='utf8')
    msg['From'] = mail_user
    msg['Subject'] = u'%s' % get_sub
    msg['To'] = mailto
    try:
        s = smtplib.SMTP()
        s.connect(mail_host)
        s.login(mail_user,mail_pwd)
        s.sendmail(mail_user,[mailto],msg.as_string())
        s.close()
        send = "OK"
    except Exception ,e:
        send = "ERROR! %s" % e
    return send


def main():
    _count_loop = 0
    while 1:
        ip_list = []
    #    if _count_loop == 0:
    #        os.system('sudo wpa_supplicant -B -i wlan0 -c /etc/wpa_supplicant/wpa_supplicant.conf')
    #        time.sleep(0.5)
    #        os.system('sudo dhclient wlan0')
        try:
            ip_list.append("eth0: %s" % get_ip_address('eth0'))
        except:
            pass
        try:
            ip_list.append("wlan0: %s" % get_ip_address('wlan0'))
        except Except,e:
            pass
        try:
            _global_ip = get_global_ip()
            ip_list.append('global ip: %s' % _global_ip)
        except :
            pass
        _get_send_status =  mail_send('my pi ip', 'simon-zzm@139.com', '%s' % ip_list)
        _count_loop +=1
        if (_get_send_status == "OK") or (_count_loop == 3):
            break
        time.sleep(3)

if __name__ == "__main__":
    main()
